/**** Fichier principal pour le client (MAC/LINUX) ****/

/** Fichiers d'inclusion **/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <poll.h>
#include <signal.h>
#include "libnet.h"

/** Variables globales */

float val_x, val_y, val_z;
float val_x_init, val_y_init, val_z_init;
int run = 1;

sigset_t ens1, ens2;
int sig;

/** Fonctions **/

/* Fonction principale */
int main(int argc,char *argv[])
{
	// Analyse des arguments
	if(argc!=3)
	{
		fprintf(stderr,"Syntaxe : client <serveur> <port>\n");
		exit(-1);
	}
	char *serveur=argv[1];
	char *port=argv[2];
	
	#ifdef DEBUG
	fprintf(stdout,"Pont sur %s port %s\n",serveur,port);
	#endif

	// Connexion au serveur
	printf("Connexion au serveur... ");
	int s= connexionServeur(serveur,port);
	if (s<0){perror("connexionServeur.socket");
	exit(EXIT_FAILURE);}

	// Communication avec le serveur
	FILE *dialogue=fdopen(s,"a+");
	FILE* fd = NULL;
	if(dialogue==NULL){ perror("gestionClient.fdopen"); exit(EXIT_FAILURE); }
	printf("OK\n");

	sigemptyset(&ens1);
	sigaddset(&ens1, SIGINT);
	sigaddset(&ens1, SIGQUIT);
	
	sigprocmask(SIG_SETMASK, &ens1, NULL);
  
  
	printf("Initialisation des valeurs de l'Oculus... ");
    fd = fopen("val.data","r");
	
	if(fd == NULL)
	{
		fclose(dialogue);
		shutdown(s,SHUT_RDWR);
		perror("Impossible d'ouvrir le fichier val.data pour l'Oculus\n");
		exit(EXIT_FAILURE);
	}
	  
	fscanf(fd,"%f %f %f",&val_x_init, &val_y_init, &val_z_init);
	
	#ifdef DEBUG
	fprintf(stdout,"Lecture Fichier (BRUT) : %0.2f %0.2f %0.2f\n",val_x_init, val_y_init, val_z_init);
	#endif
	
	fclose(fd);
	sleep(1);
	
	printf("OK\n");
	
	printf("Transmission des valeurs, CTRL_C pour arrêter\n");
	while(run)
	{
		sigpending(&ens2);
		if(sigismember(&ens2,SIGINT) || sigismember(&ens2,SIGQUIT))
		{
			val_x = 404.404;
			val_y = 404.404;
			val_z = 404.404;
  
			write(s,&val_x,sizeof(val_x));
			write(s,&val_y,sizeof(val_y));
			write(s,&val_z,sizeof(val_z));
			#ifdef DEBUG
			fprintf(stdout,"(W) %0.3f %0.3f %0.3f\n",val_x, val_y, val_z);
			#endif
			run = 0;
		}
		else
		{
			fd = NULL;
			fd = fopen("val.data","r");
	  
			if(fd == NULL)
			{
				fclose(dialogue);
				shutdown(s,SHUT_RDWR);
				perror("Impossible d'ouvrir le fichier val.data pour l'Oculus\n");
				exit(EXIT_FAILURE);
			}
	  
			fscanf(fd,"%f %f %f",&val_x, &val_y, &val_z);
			#ifdef DEBUG
			fprintf(stdout,"Lecture Fichier : %0.2f %0.2f %0.2f\n",val_x, val_y, val_z);
			#endif
			
			val_x = val_x_init - val_x;
			val_y = val_y_init - val_y;
			val_z = val_z_init - val_z;
	  
			write(s,&val_x,sizeof(val_x));
			write(s,&val_y,sizeof(val_y));
			write(s,&val_z,sizeof(val_z));
			
			#ifdef DEBUG
			fprintf(stdout,"(W) %0.2f %0.2f %0.2f\n",val_x, val_y, val_z);
			#endif
	  
			fclose(fd);
			sleep(1);
		}
	}
  
	sigemptyset(&ens1);
	sigprocmask(SIG_SETMASK, &ens1, NULL); 
	  
	fclose(dialogue);
  
	/* On termine la connexion */ 
	shutdown(s,SHUT_RDWR); 
	
	return 0;
}
